﻿package com.vamapaull.effects
{
	import flash.display.MovieClip;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.MouseEvent;
	import flash.text.TextField;

	
	
	public class TextShuffle
	{
		private var field:TextField;
		private var str:String;
		private var ind:Number;
		private var timer:Number;
		private var strLen:Number;
		private var s1:String;
		private var s2:String;
		private var s3:String;
	
		public function TextShuffle(tf:TextField,st:String) {
			field = tf;
			field.text = "";
			str = st;
			ind = 0;
			timer = 0;
			strLen = str.length;
			shuffle(field.parent as MovieClip);
		}
			
		private function shuffle(mc:MovieClip):void {
			mc.host = this;
			mc.addEventListener(Event.ENTER_FRAME, shuffleNow);
			
			function shuffleNow(e:Event):void
			{
				if (mc.host.ind <= mc.host.strLen) {
					mc.host.s1 = "";
					mc.host.s2 = mc.host.str.substr(0,mc.host.ind);
					mc.host.s3 = mc.host.str.substr(mc.host.ind);
					for (var i = 0; i < mc.host.strLen; i++) {
						mc.host.s1 = mc.host.s1+String.fromCharCode(33+Math.round(Math.random()*90));
					}
					var intString = mc.host.s2 + mc.host.s1;
					mc.host.setText(intString.substring(0,mc.host.strLen));
					if (mc.host.timer > 0) {
						mc.host.ind++;
						mc.host.timer = 0;
					}
					else {
						mc.host.timer++;
					}
				}
				else {
					mc.removeEventListener(Event.ENTER_FRAME, shuffleNow);
				}
			}
		}
		
		private function setText(txt:String):void {
			field.text = txt;
		}
	
	}

} 
